/* eslint-disable one-var */
<template>
  <div id="app">
    <div>
      <h1>Greedy Snake Game</h1>
      <h2>score: {{ score }}</h2>
      <button id="start" v-on:click="startGame">Start Game</button>
    </div>
    <canvas id="canvas" />
  </div>
</template>

<script>
import { Map } from 'immutable';
import { randomInt } from './Random';
import Snake from './Snake';
import Vec2 from './Vec2';
import {
  UP, DOWN, LEFT, RIGHT, reverseDirection,
} from './Direction';
import Food from './Food';

export default {
  name: 'App',
  data() {
    return {
      score: 0,
    };
  },
  mounted() {
    const canvas = document.getElementById('canvas');
    canvas.width = 960;
    canvas.height = 640;

    const ctx = canvas.getContext('2d');
    ctx.imageSmoothingEnabled = true;
    ctx.imageSmoothingQuality = 'high';

    const PI2 = Math.PI * 2;
    const unit = 20;
    const { width: w, height: h } = canvas;
    const uw = Math.floor(w / unit); const uh = Math.floor(h / unit);
    const unitHalf = unit / 2;

    ctx.fillStyle = 'red';
    ctx.fillRect(0, 0, w, h);

    ctx.fillStyle = 'black';
    for (let y = 0; y < uh; y++) {
      for (let x = 0; x < uw; x++) {
        const rx = x * unit + unitHalf; const ry = y * unit + unitHalf;
        ctx.beginPath();
        ctx.arc(rx, ry, 10, 0, PI2);
        ctx.fill();
      }
    }
  },

  methods: {
    startGame() {
      console.log('start');
      const canvas = document.getElementById('canvas');
      canvas.width = 960;
      canvas.height = 640;

      const ctx = canvas.getContext('2d');
      ctx.imageSmoothingEnabled = true;
      ctx.imageSmoothingQuality = 'high';

      const unit = 20;
      const { width: w, height: h } = canvas;
      const uw = Math.floor(w / unit); const uh = Math.floor(h / unit);
      const initX = randomInt(Math.floor(uw / 4), Math.floor((uw / 4) * 3));
      const initY = randomInt(Math.floor(uh / 4), Math.floor((uh / 4) * 3));
      const snake = new Snake(new Vec2(initX, initY), new Vec2(uw, uh));

      // binding keyboard event
      const map = new Map({
        ArrowUp: UP,
        ArrowDown: DOWN,
        ArrowLeft: LEFT,
        ArrowRight: RIGHT,
        w: UP,
        s: DOWN,
        a: LEFT,
        d: RIGHT,
      });
      window.addEventListener('keydown', (event) => {
        const { key, isComposing } = event;
        const { oriented } = snake;
        const rev = reverseDirection(oriented);
        const dir = map.get(key);
        if (rev === dir) return;
        snake.oriented = dir;
      });

      // draw snake
      const unitHalf = unit / 2;
      const PI2 = Math.PI * 2;
      const drawSnake = () => {
        ctx.fillStyle = 'red';
        for (let i = 0; i < snake.internal.size; i++) {
          const { x, y } = snake.internal.get(i);
          const rx = x * unit + unitHalf; const ry = y * unit + unitHalf;
          ctx.beginPath();
          ctx.arc(rx, ry, unitHalf, 0, PI2);
          ctx.fill();
        }
      };

      // draw food
      let food = Food.random();
      const foodRadiusBase = 1;
      const foodRadiusScale = 3;
      const calcRadius = (r) => (foodRadiusBase + Math.floor(r * foodRadiusScale));
      const drawFood = () => {
        ctx.fillStyle = food.color.toHexString();
        ctx.beginPath();
        const { x: fx, y: fy } = food.center;
        const dr = calcRadius(food.radius) * unit;
        const x = Math.floor(fx * uw) * unit + unitHalf;
        const y = Math.floor(fy * uh) * unit + unitHalf;

        // console.log(`${x} ${y} ${dr} ${food.color.toHexString()}`);
        ctx.arc(x, y, dr, 0, PI2);
        ctx.fill();
      };

      const checkEaten = () => {
        const { x: fx, y: fy } = food.center;
        const dr = calcRadius(food.radius) * unit;
        const cx = Math.floor(fx * uw) * unit + unitHalf;
        const cy = Math.floor(fy * uh) * unit + unitHalf;

        const x0 = cx - dr;
        const y0 = cy - dr;
        const x1 = cx + dr;
        const y1 = cy + dr;
        let { x, y } = snake.internal.first();
        x = x * unit + unitHalf;
        y = y * unit + unitHalf;
        // console.log(`${x} ${y} ${x0} ${y0} ${x1} ${y1}`);
        return (x >= x0 && x <= x1) && (y >= y0 && y <= y1);
      };

      let frame = 0;
      let failed = false;
      const draw = () => {
        ctx.clearRect(0, 0, w, h);
        ctx.fillStyle = 'black';
        ctx.fillRect(0, 0, w, h);

        if (frame % 3 === 0) {
          if (!snake.forward()) {
            failed = true;
            // eslint-disable-next-line no-alert
            alert(`Game Over, You get ${this.score} score!`);
          }
        }

        if (checkEaten()) {
          const n = calcRadius(food.radius);
          this.score += n;
          food = null;
          snake.grow(n);
        }

        drawSnake();
        if (food !== null) {
          drawFood();
        } else {
          food = Food.random();
        }

        frame++;
        frame %= 60;
        if (!failed) requestAnimationFrame(draw);
      };

      requestAnimationFrame(draw);
    },
  },
};
</script>

<style>
#app {
  font-family: Avenir, Helvetica, Arial, sans-serif;
  -webkit-font-smoothing: antialiased;
  -moz-osx-font-smoothing: grayscale;
  text-align: center;
  color: #2c3e50;
  position: absolute;
  top: 0;
  right: 0;
  left: 0;
  bottom: 0;
}

#canvas {
  width: 960px;
  height: 640px;
}

button#start{
  width: 120px;
  height: 36px;
  margin: 20px;
}
</style>
